%define name		limewire
%define version		3.5.6
%define release		1jpp
%define pkg_summary	Gnutella peer-to-peer (P2P) file sharing system

Summary:		%{pkg_summary}
Name:			%{name}
Version:		%{version}
Release:		%{release}
Epoch:			0
Url:			http://www.%{name}.com/
Source0:		%{name}-%{version}-cvs.tar.bz2
Source1:		%{name}-16.png
Source2:		%{name}-32.png
Source3:		%{name}-48.png
Patch0:			%{name}-nomacosx.patch
Patch1:			%{name}-noquicktime.patch
Patch2:			%{name}-theme.patch
Patch3:			%{name}-close.patch
Patch4:			%{name}-nosanity.patch
Patch5:			%{name}-theme-settings.patch
License:		GPL
# this isn't a Mandrake group
Group:			System/Networking
Vendor:			JPackage Project
Distribution:		JPackage
BuildArch:		noarch
Requires:		oldjavalayer
Requires:		jpackage-utils >= 0:1.5
Requires:		oldlogi.crypto
Requires:		xerces-j2
Requires:		xml-commons-apis
BuildRequires:		ant
BuildRequires:		oldjavalayer
BuildRequires:		oldlogi.crypto
BuildRequires:		jpackage-utils >= 0:1.5
BuildRequires:		xml-commons-apis
BuildRoot:		%{_tmppath}/%{name}-%{version}-root

%description
Limewire is a gnutella client written in Java. It supports a number of
advanced features like ultrapeers (like FastTrack's supernodes), automatic
download retries, freeloader punishment, etc.

%package javadoc
Summary:        	Javadoc for %{name}
Group:			Development/Java

%description javadoc
Javadoc for %{name}.

%package mdkmenu
Summary:		Mandrake menu entry for %{name}
Group:			Development
Requires:		%{name} = %{version}-%{release}

%description mdkmenu
This is a Mandrake menu system entry for %{name}.

%package rhmenu
Summary:		Red Hat menu entry for %{name}
Group:			Development
Requires:		%{name} = %{version}-%{release}

%description rhmenu
This is a Red Hat menu system entry for %{name}.

%prep
%setup -n %{name}
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;

# fix source permissions
find . -type d -exec chmod 755 {} \;
find . -type f -exec chmod 644 {} \;

# remove CVS internal files
for dir in `find . -type d -name CVS`; do rm -rf $dir; done

# remove Mac files
rm -f gui/com/limegroup/gnutella/gui/AEEventHandlerClosureUPP.java
rm -f gui/com/limegroup/gnutella/gui/MacEventHandler.java
rm -f gui/com/limegroup/gnutella/gui/menu/CocoaApplicationEventHandler.java
rm -f gui/com/limegroup/gnutella/gui/menu/PreferencesItem.java

# apply patches before we use perl
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# update for Java 1.3 and greater Collections support
find . -type f -name "*.java" -exec perl -p -i -e 's|com.sun.java.util.collections|java.util|g;' {} \;
find . -type f -name "*.java" -exec perl -p -i -e 's|java.util.Comparable|java.lang.Comparable|g;' {} \;
find . -type f -name "*.java" -exec perl -p -i -e 's|java.util.UnsupportedOperationException|java.lang.UnsupportedOperationException|g;' {} \;
perl -p -i -e 's|private final Timer ANIMATION_TIMER|private final javax.swing.Timer ANIMATION_TIMER|;' gui/com/limegroup/gnutella/gui/search/SearchResultDisplayer.java
perl -p -i -e 's|new Timer\(|new javax.swing.Timer\(|;' gui/com/limegroup/gnutella/gui/search/SearchResultDisplayer.java

# remove QuickTime for Java
find . -name "*.zip" -exec rm -f {} \;
rm -f gui/com/limegroup/gnutella/gui/mp3/QuickTimeAudioPlayer.java

# set LimeWire version
perl -p -i -e "s#\@version\@#%{version}-%{release}#" core/com/limegroup/gnutella/util/CommonUtils.java

%build
export CLASSPATH=%(build-classpath oldjavalayer oldlogi.crypto xml-commons-apis)
export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}/core

# build core
(cd core && ant core)

# build GUI
(cd gui && ant clientonly)

# build javadocs
(cd core && %javadoc -d ../doc `find . -name \*.java`)
(cd gui && %javadoc -d ../doc `find . -name \*.java`)

%install
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}

# these don't go in the jars
#install -m 644 gui/bin/donotremove.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/donotremove.htm
#install -m 644 gui/bin/limeshop.html $RPM_BUILD_ROOT%{_datadir}/%{name}/limeshop.html
rm -rf gui/bin
rm -rf gui/com/limegroup/gnutella/gui/images/flags
rm -rf root

# create all jars manually to mimic the binary distribution
(cd core && %jar cf ../LimeWire.jar `find . -name "*.class"`)
(cd gui && %jar uf ../LimeWire.jar `find . -name "*.class" -o -name "*.gif" -o -name "splash.props"`)
(cd gui && %jar uf ../LimeWire.jar `find . -name "about*.html"`)
(cd gui/lib && %jar cf ../../MessagesBundles.jar `find . -name MessagesBundle\*.properties`)
rm -f gui/themes/default_osx_theme.lwtp
(cd gui/themes && %jar cf ../themes.jar *.lwtp)

# put all docs in one place; remove duplicates
rm -f gui/Copyright.txt gui/README.txt gui/gpl.txt
mv -f core/README.txt core/core-README.txt
mv -f `find . -name "*.txt"` . || :

# install jars
install -m 644 LimeWire.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 MessagesBundles.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/themes.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/xml.war $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/lib/MessagesBundle.properties $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/update.ver $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# mdk icons
install -D -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png
install -D -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png
install -D -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png

# mdk menu
install -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\
 command="%{_bindir}/%{name}"\
 needs="X11"\
 section="Networking/File transfer"\
 title="LimeWire"\
 longtitle="%{pkg_summary}"\
 icon="limewire.png"
EOF

# rh icons
install -D -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -D -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png

# rh menu
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Networking
cat >$RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Networking/%{name}.desktop <<EOF
[Desktop Entry]
Name=LimeWire
Comment=%{pkg_summary}
Exec=%{_bindir}/%{name}
Terminal=0
Type=Application
Icon=%{name}.png
EOF

# script
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
cat > $RPM_BUILD_ROOT%{_bindir}/%{name} << EOF
#!/bin/sh
#
# jedit script
# JPackage Project (http://jpackage.sourceforge.net)

# Source functions library
. %{_datadir}/java-utils/java-functions

# Source system prefs
if [ -f %{_sysconfdir}/%{name}.conf ] ; then
  . %{_sysconfdir}/%{name}.conf
fi

# Source user prefs
if [ -f \$HOME/.%{name}rc ] ; then
  . \$HOME/.%{name}rc
fi

# Configuration
MAIN_CLASS="com.limegroup.gnutella.gui.Main"
BASE_FLAGS="-mx32m"
export CLASSPATH="\$(build-classpath oldjavalayer oldlogi.crypto xerces-j2 xml-commons-apis):\$(build-classpath-directory %{_datadir}/%{name}):%{_datadir}/%{name}/update.ver:%{_datadir}/%{name}/xml.war"

# Set parameters
set_jvm
set_flags \$BASE_FLAGS

# Let's start
run "\$@"
EOF

%post mdkmenu
%{update_menus}

%postun mdkmenu
%{clean_menus}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc *.txt
%attr(755,root,root) %{_bindir}/%{name}
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}

%files mdkmenu
%defattr(0644,root,root,0755)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files rhmenu
%defattr(0644,root,root,0755)
%{_sysconfdir}/X11/applnk/*/*
%{_datadir}/icons/*/*/apps/*

%changelog
* Tue Sep 09 2003 David Walluck <david@anti-microsoft.org> 0:3.5.6-1jpp
- 3.5.6
- rediff patches
- cookies patch no longer needed (fixed upstream)
- add nosanity patch (limewire's sanity check is actually insane!)
- include update.ver although using it is probably not a good idea
- add theme settings patch (can't write to a directory not owned by us!), and this breaks
  themes, but I'm not fixing it right now

* Tue May 06 2003 David Walluck <david@anti-microsoft.org> 0:2.9.8-1jpp
- 2.9
- include themes
- don't include GIF's not found in distributed LimeWire jar
- update for JPackage 1.5
- requires oldlogi.crypto
- require xerces-j2 plus xml-commons-apis instead of xerces-j1
- use perl to remove most MacOSX code (the rest is removed with patch)
- add patch to disable proprietary QuickTime player in favor of basic player
- add theme patch to enable all themes
- add Cookie.dat location patch
- add close patch to disallow "minimize to tray" option on shutdown
- no longer need multiuser patch
- menus now use package summary
- install icons directly from rpm source directory

* Wed Feb 19 2003 David Walluck <david@anti-microsoft.org> 2.2.8-1jpp
- release
